
package com.sample;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.testng.annotations.Test;

import com.sample.DroolsTest.Block;
import com.sample.DroolsTest.Location;
import com.sample.DroolsTest.MovementGoal;
import com.sample.DroolsTest.Named;

public class BoxTest {

	@Test
	public void test0() throws Exception {
		System.out.println("test0");
		DroolsTest test = new DroolsTest();
		test.go(false);
	}

	@Test
	public void test1() throws Exception {
		System.out.println("test1");
		DroolsTest test = new DroolsTest() {

			protected Collection<Named> getSetupData() {
				
				List<Named> data = new LinkedList<Named>();
				
				Location p1 = new Location("p1"); data.add(p1);
				Location p2 = new Location("p2"); data.add(p2);
				Location p3 = new Location("p3"); data.add(p3);
				
				Block b1 = new Block("b1"); p1.setHolding(b1); data.add(b1);
				Block b2 = new Block("b2"); p2.setHolding(b2); data.add(b2);
				Block b3 = new Block("b3"); p3.setHolding(b3); data.add(b3);
				Block b4 = new Block("b4"); b3.setHolding(b4); data.add(b4);
				
				p1.setHolding(b1);
				
				data.add(new MovementGoal("Move b2 to p1", b2, p1));
				
				return data;
			}
		};
		test.go(false);
	}

	@Test
	public void test2() throws Exception {
		System.out.println("test2");
		DroolsTest test = new DroolsTest() {

			protected Collection<Named> getSetupData() {
				
				List<Named> data = new LinkedList<Named>();
				
				Location p1 = new Location("p1"); data.add(p1);
				Location p2 = new Location("p2"); data.add(p2);
				Location p3 = new Location("p3"); data.add(p3);
				Location p4 = new Location("p4"); data.add(p4);
				Location p5 = new Location("p5"); data.add(p5);
				
				Block b1 = new Block("b1"); p1.setHolding(b1); data.add(b1);
				Block b2 = new Block("b2"); p2.setHolding(b2); data.add(b2);
				Block b3 = new Block("b3"); p3.setHolding(b3); data.add(b3);
				Block b4 = new Block("b4"); b3.setHolding(b4); data.add(b4);
				
				p1.setHolding(b1);
				
				data.add(new MovementGoal("Move b3 to p1", b3, p1));
				
				return data;
			}
		};
		test.go(false);
	}

	@Test
	public void test3() throws Exception {
		System.out.println("test3");
		DroolsTest test = new DroolsTest() {

			protected Collection<Named> getSetupData() {
				
				List<Named> data = new LinkedList<Named>();
				
				Location p1 = new Location("p1"); data.add(p1);
				Location p2 = new Location("p2"); data.add(p2);
				Location p3 = new Location("p3"); data.add(p3);
				
				Block b1 = new Block("b1"); p1.setHolding(b1); data.add(b1);
				Block b2 = new Block("b2"); p2.setHolding(b2); data.add(b2);
				Block b3 = new Block("b3"); p3.setHolding(b3); data.add(b3);
				Block b4 = new Block("b4"); b3.setHolding(b4); data.add(b4);
				
				p1.setHolding(b1);
				
				data.add(new MovementGoal("Move b3 off " + p3.getName(), b3, null));
				
				return data;
			}
		};
		test.go(false);
	}
	
}
